# Class AbstractElementVisitor14<R,P>

java.lang.Object
javax.lang.model.util.AbstractElementVisitor6<R,P>
javax.lang.model.util.AbstractElementVisitor7<R,P>
javax.lang.model.util.AbstractElementVisitor8<R,P>
javax.lang.model.util.AbstractElementVisitor9<R,P>
javax.lang.model.util.AbstractElementVisitor14<R,P>

Type Parameters:
  `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
  `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.

All Implemented Interfaces:
  `ElementVisitor<R,P>`

Direct Known Subclasses:
  `AbstractElementVisitorPreviewPREVIEW`

@SupportedSourceVersion(RELEASE_26) public abstract class AbstractElementVisitor14<R,P> extends AbstractElementVisitor9<R,P>
A skeletal visitor of program elements with default behavior appropriate for the `RELEASE_14` source version.

Since:
  16
See Also:
  - Compatibility note for subclasses
  - `AbstractElementVisitor6`
  - `AbstractElementVisitor7`
  - `AbstractElementVisitor8`
  - `AbstractElementVisitor9`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `AbstractElementVisitor14()`
  Constructor for concrete subclasses to call.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract R`
  `visitRecordComponent(RecordComponentElement e, P p)`
  Visits a record component element.

  ### Methods declared in class AbstractElementVisitor9

  `visitModule`
  Modifier and Type
  Method
  Description
  `abstract R`
  `visitModule(ModuleElement e, P p)`
  Visits a module element.

  ### Methods declared in class AbstractElementVisitor6

  `visit, visit, visitUnknown`
  Modifier and Type
  Method
  Description
  `final R`
  `visit(Element e)`
  Visits any program element as if by passing itself to that element's `accept` method and passing `null` for the additional parameter.
  `final R`
  `visit(Element e, P p)`
  Visits any program element as if by passing itself to that element's `accept` method.
  `R`
  `visitUnknown(Element e, P p)`
  Visits an unknown kind of element.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

  ### Methods declared in interface ElementVisitor

  `visitExecutable, visitPackage, visitType, visitTypeParameter, visitVariable`
  Modifier and Type
  Method
  Description
  `R`
  `visitExecutable(ExecutableElement e, P p)`
  Visits an executable element.
  `R`
  `visitPackage(PackageElement e, P p)`
  Visits a package element.
  `R`
  `visitType(TypeElement e, P p)`
  Visits a type element.
  `R`
  `visitTypeParameter(TypeParameterElement e, P p)`
  Visits a type parameter element.
  `R`
  `visitVariable(VariableElement e, P p)`
  Visits a variable element.

- ## Constructor Details

  - ### AbstractElementVisitor14

    protected AbstractElementVisitor14()
    Constructor for concrete subclasses to call.

- ## Method Details

  - ### visitRecordComponent

    public abstract R visitRecordComponent(RecordComponentElement e, P p)
    Visits a record component element.
    Specified by:
      `visitRecordComponent` in interface `ElementVisitor<R,P>`
    Overrides:
      `visitRecordComponent` in class `AbstractElementVisitor6<R,P>`
    Implementation Requirements:
      Visits a `RecordComponentElement` in a manner defined by a subclass.
    Parameters:
      `e` - the element to visit
      `p` - a visitor-specified parameter
    Returns:
      a visitor-specified result